//************************************************************************************
//**  
//**  File name:     C:\Documents and Settings\S\Desktop\FlowCode\RTC\DS1305test1.c
//**  Generated by:  Flowcode v3.2.0.36
//**  Date:          Sunday, July 15, 2007 19:00:14
//**  Licence:       Professional
//**  Registered to: Michael Sean King
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


//Defines for microcontroller
#define P16F877
#define MX_EE
#define MX_EE_SIZE 256
#define MX_SPI
#define MX_SPI_C
#define MX_SPI_SDI 4
#define MX_SPI_SDO 5
#define MX_SPI_SCK 3
#define MX_UART
#define MX_UART_C
#define MX_UART_TX 6
#define MX_UART_RX 7
#define MX_MI2C
#define MX_I2C_SDA 4
#define MX_I2C_SCL 3
#define MX_PWM
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 trisc
#define MX_PWM_1 2
#define MX_PWM_TRIS2 trisc
#define MX_PWM_2 1

//Functions
#include <system.h>
#pragma CLOCK_FREQ 19660800

//Configuration data

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode V3\FCD\internals.h"

//Macro function declarations
void FCM_RTCwrite(char FCL_ADDR, char FCL_DATA);
char FCM_RTCread(char FCL_ADDR);
void FCM_LCDbcd(char FCL_DATA);


//Variable declarations
char FCV_DIGIT;
char FCV_MEM_VAL;




//SPI0: //Macro function declarations

void FCD_SPI0_SPI_Init();
void FCD_SPI0_SPI_Uninit();
void FCD_SPI0_SPI_Send_Char(char Char);
char FCD_SPI0_SPI_Get_Char();
void FCD_SPI0_DAC_Send_Char(char Char);
void FCD_SPI0_NVM_Send_Char(char hi_addr, char lo_addr, char Char);
char FCD_SPI0_NVM_Get_Char(char hi_addr, char lo_addr);
char FCD_SPI0_FramOutput(char Char);
void FCD_SPI0_EnableFRAM();
void FCD_SPI0_DisableFRAM();


//LCDDisplay0: //Macro function declarations

void FCD_LCDDisplay0_GetDefines();
void FCD_LCDDisplay0_Start();
void FCD_LCDDisplay0_Clear();
void FCD_LCDDisplay0_PrintASCII(char Character);
void FCD_LCDDisplay0_Command(char in);
void FCD_LCDDisplay0_RawSend(char in, char mask);
void FCD_LCDDisplay0_Cursor(char x, char y);
void FCD_LCDDisplay0_PrintNumber(short Number);
void FCD_LCDDisplay0_PrintString(char* String, char MSZ_String);

//Supplementary defines


//Macro implementations

void FCM_RTCwrite(char FCL_ADDR, char FCL_DATA)
{
	
	//Output
	//Output: 0xff -> PORT C
	trisc = trisc & 0xbf;
	portc = (portc & 0xbf) | (0xff & 0x40);


	//Call Component Macro
	//Call Component Macro: SPI(0)::SPI_Send_Char(RTCwrite.addr)
	FCD_SPI0_SPI_Send_Char(FCL_ADDR);


	//Call Component Macro
	//Call Component Macro: SPI(0)::SPI_Send_Char(RTCwrite.data)
	FCD_SPI0_SPI_Send_Char(FCL_DATA);


	//Output
	//Output: 0 -> PORT C
	trisc = trisc & 0xbf;
	portc = (portc & 0xbf) | (0 & 0x40);


}

char FCM_RTCread(char FCL_ADDR)
{
	
	char FCR_RETVAL;

	//Output
	//Output: 0xff -> PORT C
	trisc = trisc & 0xbf;
	portc = (portc & 0xbf) | (0xff & 0x40);


	//Call Component Macro
	//Call Component Macro: SPI(0)::SPI_Send_Char(RTCread.addr)
	FCD_SPI0_SPI_Send_Char(FCL_ADDR);


	//Call Component Macro
	//Call Component Macro: RTCread.Return=SPI(0)::SPI_Get_Char
	FCR_RETVAL = FCD_SPI0_SPI_Get_Char();


	//Output
	//Output: 0 -> PORT C
	trisc = trisc & 0xbf;
	portc = (portc & 0xbf) | (0 & 0x40);


	return (FCR_RETVAL);
}

void FCM_LCDbcd(char FCL_DATA)
{
	
	//Local variable definitions
	char FCL_DIGIT;

	//Calculation
	//Calculation:
	//  LCDbcd.digit = ( LCDbcd.data AND 0xf0 ) >> 4
	FCL_DIGIT =  ( FCL_DATA & 0xf0 ) >> 4 ;
	

	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintNumber(LCDbcd.digit)
	FCD_LCDDisplay0_PrintNumber(FCL_DIGIT);


	//Calculation
	//Calculation:
	//  LCDbcd.digit = LCDbcd.data AND 0x0f
	FCL_DIGIT =  FCL_DATA & 0x0f ;
	

	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::PrintNumber(LCDbcd.digit)
	FCD_LCDDisplay0_PrintNumber(FCL_DIGIT);


}



//SPI0: //Macro implementations


void FCD_SPI0_SPI_Init()
{
	//GetSPI_InitCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 2
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	//initialise spi
	#ifdef MX_SPI_B
	    set_bit(trisb,MX_SPI_SDI);
	    clear_bit(trisb,MX_SPI_SDO);
	    clear_bit(trisb,MX_SPI_SCK);
	    clear_bit(trisb,SPI_DAC_EN);
	    clear_bit(trisb,SPI_FRM_EN);

	    //disable SPI devices
	    set_bit(portb, SPI_DAC_EN);
	    set_bit(portb, SPI_FRM_EN);
	#endif

	#ifdef MX_SPI_C
	    set_bit(trisc,MX_SPI_SDI);
	    clear_bit(trisc,MX_SPI_SDO);
	    clear_bit(trisc,MX_SPI_SCK);
	    clear_bit(trisc,SPI_DAC_EN);
	    clear_bit(trisc,SPI_FRM_EN);

	    //disable SPI devices
	    set_bit(portc, SPI_DAC_EN);
	    set_bit(portc, SPI_FRM_EN);
	#endif

	sspstat = SPI_CKE | SPI_SMP;
	#ifdef SSPCON
	sspcon = SPI_SSPM | SPI_CKP;
	set_bit(sspcon, SSPEN);
	#endif
	#ifdef SSPCON1
	sspcon1 = SPI_SSPM | SPI_CKP;
	set_bit(sspcon1, SSPEN);
	#endif

}

void FCD_SPI0_SPI_Uninit()
{
	//GetSPI_UninitCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 2
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	#ifdef SSPCON
	clear_bit(sspcon, SSPEN);
	#endif
	#ifdef SSPCON1
	clear_bit(sspcon1, SSPEN);
	#endif
}

void FCD_SPI0_SPI_Send_Char(char Char)
{
	//GetSPI_Send_CharCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 2
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	//send the Char
	sspbuf = Char;

	//wait until sspbuf is empty
	while ((sspstat & 0x01) == 0);

}

char FCD_SPI0_SPI_Get_Char()
{
	//GetSPI_Get_CharCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 2
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	char retVal = 0;
	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	//send a dummy Char
	sspbuf = 0x5A;

	//wait until sspbuf is empty
	while ((sspstat & 0x01) == 0);

	//receive the Char
	retVal = sspbuf;

	return (retVal);
}

void FCD_SPI0_DAC_Send_Char(char Char)
{
	//GetDAC__Send_Char Code

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 2
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	char dac_val;

	//enable dac
	#ifdef MX_SPI_B
	    clear_bit(portb, SPI_DAC_EN);
	#endif
	#ifdef MX_SPI_C
	    clear_bit(portc, SPI_DAC_EN);
	#endif

	dac_val = (Char & 0xF0) >> 4;
	sspbuf = dac_val;
	delay_10us(1);

	dac_val = (Char & 0x0F) << 4;
	sspbuf = dac_val;
	delay_10us(1);

	//disable dac
	#ifdef MX_SPI_B
	    set_bit(portb, SPI_DAC_EN);
	#endif
	#ifdef MX_SPI_C
	    set_bit(portc, SPI_DAC_EN);
	#endif

}

void FCD_SPI0_NVM_Send_Char(char hi_addr, char lo_addr, char Char)
{
	//GetNVM_Send_CharCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 2
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	//disable interrupts
	clear_bit(intcon, GIE);
	//enable writes
	FCD_SPI0_EnableFRAM();
	FCD_SPI0_FramOutput(FRAM_WREN);
	FCD_SPI0_DisableFRAM();

	//delay here???
	//delay_us(100);

	//send write-fram command, address and data
	FCD_SPI0_EnableFRAM();
	FCD_SPI0_FramOutput(FRAM_WRITE);
	FCD_SPI0_FramOutput(hi_addr);
	FCD_SPI0_FramOutput(lo_addr);
	FCD_SPI0_FramOutput(Char);
	FCD_SPI0_DisableFRAM();

	//re-enable interrupts
	set_bit(intcon, GIE);

}

char FCD_SPI0_NVM_Get_Char(char hi_addr, char lo_addr)
{
	//GetNVM_Send_CharCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 2
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	char retVal;

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	//disable interrupts
	clear_bit(intcon, GIE);

	FCD_SPI0_EnableFRAM();

	//send read-fram command and address
	FCD_SPI0_FramOutput(FRAM_READ);
	FCD_SPI0_FramOutput(hi_addr);
	FCD_SPI0_FramOutput(lo_addr);

	//read the data
	retVal = FCD_SPI0_FramOutput(0x5A);  //don't care byte of 0x5A

	FCD_SPI0_DisableFRAM();

	//re-enable interrupts
	set_bit(intcon, GIE);

	return(retVal);

}

char FCD_SPI0_FramOutput(char Char)
{
	//GetFramOutputCode
	char retVal;

	sspbuf = Char;

	//wait until byte has been received
	while ((sspstat & 0x01) == 0);

	retVal = sspbuf;

	return (retVal);

}

void FCD_SPI0_EnableFRAM()
{
	//enable FRAM
	#ifdef MX_SPI_B
	    clear_bit(portb, SPI_FRM_EN);
	#endif
	#ifdef MX_SPI_C
	    clear_bit(portc, SPI_FRM_EN);
	#endif

}

void FCD_SPI0_DisableFRAM()
{
	//disable FRAM
	#ifdef MX_SPI_B
	    set_bit(portb, SPI_FRM_EN);
	#endif
	#ifdef MX_SPI_C
	    set_bit(portc, SPI_FRM_EN);
	#endif

}



//LCDDisplay0: //Macro implementations


void FCD_LCDDisplay0_GetDefines()
{
	
	}  //Dummy end of function to allow defines to be added correctly

	//component connections
	#define LCD_721910_PORT    portb
	#define LCD_721910_TRIS    trisb
	#define LCD_721910_BIT0    0
	#define LCD_721910_BIT1    1
	#define LCD_721910_BIT2    2
	#define LCD_721910_BIT3    3
	#define LCD_721910_RS      4
	#define LCD_721910_E       5

	#ifdef _BOOSTC
	  #define LCD_721910_DELAY   delay_10us(10)
	#endif
	#ifdef _C2C_
	  #define LCD_721910_DELAY   delay_us(100)
	#endif
	#ifndef LCD_721910_DELAY
	  #define LCD_721910_DELAY   delay_us(100)
	#endif



	//internal function prototypes
	void LCD_721910_RawSend(char nIn, char nMask);

	//internal function implementations
	void LCD_721910_RawSend(char nIn, char nMask)
	{
		unsigned char pt;
		unsigned char outVal;
		outVal = LCD_721910_PORT;
		clear_bit(outVal, LCD_721910_BIT0);
		clear_bit(outVal, LCD_721910_BIT1);
		clear_bit(outVal, LCD_721910_BIT2);
		clear_bit(outVal, LCD_721910_BIT3);
		clear_bit(outVal, LCD_721910_RS);
		clear_bit(outVal, LCD_721910_E);
		pt = ((nIn >> 4) & 0x0f);
		if (pt & 0x01)
		    set_bit(outVal, LCD_721910_BIT0);
		if (pt & 0x02)
		    set_bit(outVal, LCD_721910_BIT1);
		if (pt & 0x04)
		    set_bit(outVal, LCD_721910_BIT2);
		if (pt & 0x08)
		    set_bit(outVal, LCD_721910_BIT3);
		if (nMask)
		    set_bit(outVal, LCD_721910_RS);
		LCD_721910_PORT = outVal;
		set_bit (LCD_721910_PORT, LCD_721910_E);
		LCD_721910_DELAY;
		clear_bit (LCD_721910_PORT, LCD_721910_E);
		pt = (nIn & 0x0f);
		LCD_721910_DELAY;
		outVal = LCD_721910_PORT;
		clear_bit(outVal, LCD_721910_BIT0);
		clear_bit(outVal, LCD_721910_BIT1);
		clear_bit(outVal, LCD_721910_BIT2);
		clear_bit(outVal, LCD_721910_BIT3);
		clear_bit(outVal, LCD_721910_RS);
		clear_bit(outVal, LCD_721910_E);
		if (pt & 0x01)
		    set_bit(outVal, LCD_721910_BIT0);
		if (pt & 0x02)
		    set_bit(outVal, LCD_721910_BIT1);
		if (pt & 0x04)
		    set_bit(outVal, LCD_721910_BIT2);
		if (pt & 0x08)
		    set_bit(outVal, LCD_721910_BIT3);
		if (nMask)
		    set_bit(outVal, LCD_721910_RS);
		LCD_721910_PORT = outVal;
		LCD_721910_DELAY;
		set_bit (LCD_721910_PORT, LCD_721910_E);
		LCD_721910_DELAY;
		clear_bit (LCD_721910_PORT, LCD_721910_E);
		LCD_721910_DELAY;
	}

	// Dummy function to close the defines section off
	void LCD_721910_Dummy_Function();
	void LCD_721910_Dummy_Function()
	{

}

void FCD_LCDDisplay0_Start()
{
	
		clear_bit(LCD_721910_TRIS, LCD_721910_BIT0);
		clear_bit(LCD_721910_TRIS, LCD_721910_BIT1);
		clear_bit(LCD_721910_TRIS, LCD_721910_BIT2);
		clear_bit(LCD_721910_TRIS, LCD_721910_BIT3);
		clear_bit(LCD_721910_TRIS, LCD_721910_RS);
		clear_bit(LCD_721910_TRIS, LCD_721910_E);

		delay_ms(12);

		LCD_721910_RawSend(0x33, 0);
		delay_ms(2);
		LCD_721910_RawSend(0x32, 0);
		delay_ms(2);
		LCD_721910_RawSend(0x2c, 0);
		delay_ms(2);
		LCD_721910_RawSend(0x06, 0);
		delay_ms(2);
		LCD_721910_RawSend(0x0c, 0);
		delay_ms(2);

		//clear the display
		LCD_721910_RawSend(0x01, 0);
		delay_ms(2);
		LCD_721910_RawSend(0x02, 0);
		delay_ms(2);

}

void FCD_LCDDisplay0_Clear()
{
	
		LCD_721910_RawSend(0x01, 0);
		delay_ms(2);
		LCD_721910_RawSend(0x02, 0);
		delay_ms(2);

}

void FCD_LCDDisplay0_PrintASCII(char Character)
{
	
		LCD_721910_RawSend(Character, 0x10);

}

void FCD_LCDDisplay0_Command(char in)
{
	
		LCD_721910_RawSend(in, 0);
		delay_ms(2);

}

void FCD_LCDDisplay0_RawSend(char in, char mask)
{
	//Error Reading Code For LCD Display::Macro_RawSend

}

void FCD_LCDDisplay0_Cursor(char x, char y)
{
	
	  #if (2 == 1)
	    y=0x80;
	  #endif

	  #if (2 == 2)
		if (y==0)
			y=0x80;
		else
			y=0xc0;
	  #endif

	  #if (2 == 4)
		if (y==0)
			y=0x80;
		else if (y==1)
			y=0xc0;
		else if (y==2)
			y=0x94;
		else
			y=0xd4;
	  #endif

		LCD_721910_RawSend(y+x, 0);
		delay_ms(2);

}

void FCD_LCDDisplay0_PrintNumber(short Number)
{
	
		short tmp_int;
		char tmp_byte;
		if (Number < 0)
		{
			LCD_721910_RawSend('-', 0x10);
			Number = 0 - Number;
		}

		tmp_int = Number;
		if (Number >= 10000)
		{
			tmp_byte = tmp_int / 10000;
			LCD_721910_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 10000;
				tmp_byte--;
			}
		}
		if (Number >= 1000)
		{
			tmp_byte = tmp_int / 1000;
			LCD_721910_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 1000;
				tmp_byte--;
			}
		}
		if (Number >= 100)
		{
			tmp_byte = tmp_int / 100;
			LCD_721910_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 100;
				tmp_byte--;
			}
		}
		if (Number >= 10)
		{
			tmp_byte = tmp_int / 10;
			LCD_721910_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 10;
				tmp_byte--;
			}
		}
		LCD_721910_RawSend('0' + tmp_int, 0x10);

}

void FCD_LCDDisplay0_PrintString(char* String, char MSZ_String)
{
	
		char idx;
		for (idx=0; idx<MSZ_String; idx++)
		{
			if (String[idx]==0)
			{
				break;
			}
			LCD_721910_RawSend(String[idx], 0x10);
		}

}

//Supplementary implementations


void main()
{
	
	//Initialisation
	adcon1 = 0x07;

	
	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 2
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2


	//Interrupt initialisation code
	option_reg = 0xC0;


	//Delay
	//Delay: 500 ms
	delay_ms(255);
	delay_ms(245);


	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::Start
	FCD_LCDDisplay0_Start();


	//Call Component Macro
	//Call Component Macro: SPI(0)::SPI_Init
	FCD_SPI0_SPI_Init();


	//Call Macro
	//Call Macro: RTCwrite(0x8f, 0x00)
	FCM_RTCwrite(0x8f, 0x00);


	//Delay
	//Delay: 1 ms
	delay_ms(1);


	//Call Macro
	//Call Macro: RTCwrite(0x80, 0x00)
	FCM_RTCwrite(0x80, 0x00);


	//Call Macro
	//Call Macro: RTCwrite(0x81, 0x00)
	FCM_RTCwrite(0x81, 0x00);


	//Call Macro
	//Call Macro: RTCwrite(0x82, 0x00)
	FCM_RTCwrite(0x82, 0x00);


	//Loop
	//Loop: While 1
	while( 1 )
	{
		//Delay
		//Delay: 100 ms
		delay_ms(100);


		//Call Component Macro
		//Call Component Macro: LCDDisplay(0)::Clear
		FCD_LCDDisplay0_Clear();


		//Call Macro
		//Call Macro: mem_val=RTCread(0x02)
		FCV_MEM_VAL = FCM_RTCread(0x02);


		//Call Macro
		//Call Macro: LCDbcd(mem_val)
		FCM_LCDbcd(FCV_MEM_VAL);


		//Call Component Macro
		//Call Component Macro: LCDDisplay(0)::PrintASCII(':')
		FCD_LCDDisplay0_PrintASCII(':');


		//Call Macro
		//Call Macro: mem_val=RTCread(0x01)
		FCV_MEM_VAL = FCM_RTCread(0x01);


		//Call Macro
		//Call Macro: LCDbcd(mem_val)
		FCM_LCDbcd(FCV_MEM_VAL);


		//Call Component Macro
		//Call Component Macro: LCDDisplay(0)::PrintASCII(':')
		FCD_LCDDisplay0_PrintASCII(':');


		//Call Macro
		//Call Macro: mem_val=RTCread(0x00)
		FCV_MEM_VAL = FCM_RTCread(0x00);


		//Call Macro
		//Call Macro: LCDbcd(mem_val)
		FCM_LCDbcd(FCV_MEM_VAL);


	}


	mainendloop: goto mainendloop;
}

void interrupt(void)
{
	 
}

