//************************************************************************************
//**  
//**  File name:     C:\Documents and Settings\S\Desktop\FlowCode\RTC\DS1305test2.c
//**  Generated by:  Flowcode v3.2.0.36
//**  Date:          Sunday, July 15, 2007 20:15:28
//**  Licence:       Professional
//**  Registered to: Michael Sean King
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


//Defines for microcontroller
#define P16F877
#define MX_EE
#define MX_EE_SIZE 256
#define MX_SPI
#define MX_SPI_C
#define MX_SPI_SDI 4
#define MX_SPI_SDO 5
#define MX_SPI_SCK 3
#define MX_UART
#define MX_UART_C
#define MX_UART_TX 6
#define MX_UART_RX 7
#define MX_MI2C
#define MX_I2C_SDA 4
#define MX_I2C_SCL 3
#define MX_PWM
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 trisc
#define MX_PWM_1 2
#define MX_PWM_TRIS2 trisc
#define MX_PWM_2 1

//Functions
#include <system.h>
#pragma CLOCK_FREQ 19660800

//Configuration data

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode V3\FCD\internals.h"

//Macro function declarations
void FCM_RTCwrite(char FCL_ADDR, char FCL_DATA);
char FCM_RTCread(char FCL_ADDR);
void FCM_LEDtime(char FCL_HIVAL, char FCL_LOVAL);


//Variable declarations
char FCV_SEC_VAL;
char FCV_MIN_VAL;
char FCV_HR_VAL;




//SPI0: //Macro function declarations

void FCD_SPI0_SPI_Init();
void FCD_SPI0_SPI_Uninit();
void FCD_SPI0_SPI_Send_Char(char Char);
char FCD_SPI0_SPI_Get_Char();
void FCD_SPI0_DAC_Send_Char(char Char);
void FCD_SPI0_NVM_Send_Char(char hi_addr, char lo_addr, char Char);
char FCD_SPI0_NVM_Get_Char(char hi_addr, char lo_addr);
char FCD_SPI0_FramOutput(char Char);
void FCD_SPI0_EnableFRAM();
void FCD_SPI0_DisableFRAM();


//LED7Seg40: //Macro function declarations

void FCD_LED7Seg40_ShowDigit(char Digit, char Value, char DecimalPoint);

//Supplementary defines


//Macro implementations

void FCM_RTCwrite(char FCL_ADDR, char FCL_DATA)
{
	
	//Output
	//Output: 0xff -> PORT C
	trisc = trisc & 0xbf;
	portc = (portc & 0xbf) | (0xff & 0x40);


	//Call Component Macro
	//Call Component Macro: SPI(0)::SPI_Send_Char(RTCwrite.addr)
	FCD_SPI0_SPI_Send_Char(FCL_ADDR);


	//Call Component Macro
	//Call Component Macro: SPI(0)::SPI_Send_Char(RTCwrite.data)
	FCD_SPI0_SPI_Send_Char(FCL_DATA);


	//Output
	//Output: 0 -> PORT C
	trisc = trisc & 0xbf;
	portc = (portc & 0xbf) | (0 & 0x40);


}

char FCM_RTCread(char FCL_ADDR)
{
	
	char FCR_RETVAL;

	//Output
	//Output: 0xff -> PORT C
	trisc = trisc & 0xbf;
	portc = (portc & 0xbf) | (0xff & 0x40);


	//Call Component Macro
	//Call Component Macro: SPI(0)::SPI_Send_Char(RTCread.addr)
	FCD_SPI0_SPI_Send_Char(FCL_ADDR);


	//Call Component Macro
	//Call Component Macro: RTCread.Return=SPI(0)::SPI_Get_Char
	FCR_RETVAL = FCD_SPI0_SPI_Get_Char();


	//Output
	//Output: 0 -> PORT C
	trisc = trisc & 0xbf;
	portc = (portc & 0xbf) | (0 & 0x40);


	return (FCR_RETVAL);
}

void FCM_LEDtime(char FCL_HIVAL, char FCL_LOVAL)
{
	
	//Local variable definitions
	char FCL_DIGIT1;
	char FCL_DIGIT2;
	char FCL_DIGIT3;
	char FCL_DIGIT0;

	//Calculation
	//Calculation:
	//  LEDtime.digit3 = ( LEDtime.HIval & 0xf0 ) >> 4
	//  LEDtime.digit2 = LEDtime.HIval & 0x0f
	//  LEDtime.digit1 = ( LEDtime.LOval & 0xf0 ) >> 4
	//  LEDtime.digit0 = LEDtime.LOval & 0x0f
	FCL_DIGIT3 =  ( FCL_HIVAL & 0xf0 ) >> 4 ;
	FCL_DIGIT2 =  FCL_HIVAL & 0x0f ;
	FCL_DIGIT1 =  ( FCL_LOVAL & 0xf0 ) >> 4 ;
	FCL_DIGIT0 =  FCL_LOVAL & 0x0f ;
	

	//Call Component Macro
	//Call Component Macro: LED7Seg4(0)::ShowDigit(0, LEDtime.digit0, 0)
	FCD_LED7Seg40_ShowDigit(0, FCL_DIGIT0, 0);


	//Delay
	//Delay: 2 ms
	delay_ms(2);


	//Call Component Macro
	//Call Component Macro: LED7Seg4(0)::ShowDigit(1, LEDtime.digit1, 0)
	FCD_LED7Seg40_ShowDigit(1, FCL_DIGIT1, 0);


	//Delay
	//Delay: 2 ms
	delay_ms(2);


	//Call Component Macro
	//Call Component Macro: LED7Seg4(0)::ShowDigit(2, LEDtime.digit2, 1)
	FCD_LED7Seg40_ShowDigit(2, FCL_DIGIT2, 1);


	//Delay
	//Delay: 2 ms
	delay_ms(2);


	//Call Component Macro
	//Call Component Macro: LED7Seg4(0)::ShowDigit(3, LEDtime.digit3, 0)
	FCD_LED7Seg40_ShowDigit(3, FCL_DIGIT3, 0);


	//Delay
	//Delay: 2 ms
	delay_ms(2);


}



//SPI0: //Macro implementations


void FCD_SPI0_SPI_Init()
{
	//GetSPI_InitCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 0
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	//initialise spi
	#ifdef MX_SPI_B
	    set_bit(trisb,MX_SPI_SDI);
	    clear_bit(trisb,MX_SPI_SDO);
	    clear_bit(trisb,MX_SPI_SCK);
	    clear_bit(trisb,SPI_DAC_EN);
	    clear_bit(trisb,SPI_FRM_EN);

	    //disable SPI devices
	    set_bit(portb, SPI_DAC_EN);
	    set_bit(portb, SPI_FRM_EN);
	#endif

	#ifdef MX_SPI_C
	    set_bit(trisc,MX_SPI_SDI);
	    clear_bit(trisc,MX_SPI_SDO);
	    clear_bit(trisc,MX_SPI_SCK);
	    clear_bit(trisc,SPI_DAC_EN);
	    clear_bit(trisc,SPI_FRM_EN);

	    //disable SPI devices
	    set_bit(portc, SPI_DAC_EN);
	    set_bit(portc, SPI_FRM_EN);
	#endif

	sspstat = SPI_CKE | SPI_SMP;
	#ifdef SSPCON
	sspcon = SPI_SSPM | SPI_CKP;
	set_bit(sspcon, SSPEN);
	#endif
	#ifdef SSPCON1
	sspcon1 = SPI_SSPM | SPI_CKP;
	set_bit(sspcon1, SSPEN);
	#endif

}

void FCD_SPI0_SPI_Uninit()
{
	//GetSPI_UninitCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 0
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	#ifdef SSPCON
	clear_bit(sspcon, SSPEN);
	#endif
	#ifdef SSPCON1
	clear_bit(sspcon1, SSPEN);
	#endif
}

void FCD_SPI0_SPI_Send_Char(char Char)
{
	//GetSPI_Send_CharCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 0
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	//send the Char
	sspbuf = Char;

	//wait until sspbuf is empty
	while ((sspstat & 0x01) == 0);

}

char FCD_SPI0_SPI_Get_Char()
{
	//GetSPI_Get_CharCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 0
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	char retVal = 0;
	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	//send a dummy Char
	sspbuf = 0x5A;

	//wait until sspbuf is empty
	while ((sspstat & 0x01) == 0);

	//receive the Char
	retVal = sspbuf;

	return (retVal);
}

void FCD_SPI0_DAC_Send_Char(char Char)
{
	//GetDAC__Send_Char Code

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 0
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	char dac_val;

	//enable dac
	#ifdef MX_SPI_B
	    clear_bit(portb, SPI_DAC_EN);
	#endif
	#ifdef MX_SPI_C
	    clear_bit(portc, SPI_DAC_EN);
	#endif

	dac_val = (Char & 0xF0) >> 4;
	sspbuf = dac_val;
	delay_10us(1);

	dac_val = (Char & 0x0F) << 4;
	sspbuf = dac_val;
	delay_10us(1);

	//disable dac
	#ifdef MX_SPI_B
	    set_bit(portb, SPI_DAC_EN);
	#endif
	#ifdef MX_SPI_C
	    set_bit(portc, SPI_DAC_EN);
	#endif

}

void FCD_SPI0_NVM_Send_Char(char hi_addr, char lo_addr, char Char)
{
	//GetNVM_Send_CharCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 0
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	//disable interrupts
	clear_bit(intcon, GIE);
	//enable writes
	FCD_SPI0_EnableFRAM();
	FCD_SPI0_FramOutput(FRAM_WREN);
	FCD_SPI0_DisableFRAM();

	//delay here???
	//delay_us(100);

	//send write-fram command, address and data
	FCD_SPI0_EnableFRAM();
	FCD_SPI0_FramOutput(FRAM_WRITE);
	FCD_SPI0_FramOutput(hi_addr);
	FCD_SPI0_FramOutput(lo_addr);
	FCD_SPI0_FramOutput(Char);
	FCD_SPI0_DisableFRAM();

	//re-enable interrupts
	set_bit(intcon, GIE);

}

char FCD_SPI0_NVM_Get_Char(char hi_addr, char lo_addr)
{
	//GetNVM_Send_CharCode

	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 0
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2

	char retVal;

	#ifndef MX_SPI
	    asm error "Chip does not have SPI capability"
	#endif

	//disable interrupts
	clear_bit(intcon, GIE);

	FCD_SPI0_EnableFRAM();

	//send read-fram command and address
	FCD_SPI0_FramOutput(FRAM_READ);
	FCD_SPI0_FramOutput(hi_addr);
	FCD_SPI0_FramOutput(lo_addr);

	//read the data
	retVal = FCD_SPI0_FramOutput(0x5A);  //don't care byte of 0x5A

	FCD_SPI0_DisableFRAM();

	//re-enable interrupts
	set_bit(intcon, GIE);

	return(retVal);

}

char FCD_SPI0_FramOutput(char Char)
{
	//GetFramOutputCode
	char retVal;

	sspbuf = Char;

	//wait until byte has been received
	while ((sspstat & 0x01) == 0);

	retVal = sspbuf;

	return (retVal);

}

void FCD_SPI0_EnableFRAM()
{
	//enable FRAM
	#ifdef MX_SPI_B
	    clear_bit(portb, SPI_FRM_EN);
	#endif
	#ifdef MX_SPI_C
	    clear_bit(portc, SPI_FRM_EN);
	#endif

}

void FCD_SPI0_DisableFRAM()
{
	//disable FRAM
	#ifdef MX_SPI_B
	    set_bit(portb, SPI_FRM_EN);
	#endif
	#ifdef MX_SPI_C
	    set_bit(portc, SPI_FRM_EN);
	#endif

}



//LED7Seg40: //Macro implementations


void FCD_LED7Seg40_ShowDigit(char Digit, char Value, char DecimalPoint)
{
	if (Digit >= 0 && Digit <= 3)
	{
		char cAnode[4]={0x08, 0x04, 0x02, 0x01};
		char cCathode[10]={0xc0, 0xf9, 0xa4, 0xb0, 0x99, 0x92, 0x82, 0xf8, 0x80, 0x98};
		trisa = trisa & 0xf0;
		trisb = trisb & 0x00;
		porta = porta & 0xf0;
		char cCatValue = cCathode[Value % 10];
		if (DecimalPoint) cCatValue &= 0x7f;
		portb = portb & 0x00 | cCatValue;
		porta = porta & 0xf0 | cAnode[Digit];
	}
}

//Supplementary implementations


void main()
{
	
	//Initialisation
	adcon1 = 0x07;

	
	//SPI COMPONENT DEFINES
	#define SPI_DAC_EN 7
	#define SPI_FRM_EN 6

	#define SPI_SSPM 0
	#define SPI_CKP 16
	#define SPI_CKE 0
	#define SPI_SMP 0

	#define FRAM_WREN  6
	#define FRAM_WRDI  4
	#define FRAM_RDSR  5
	#define FRAM_WRSR  1
	#define FRAM_READ  3
	#define FRAM_WRITE 2


	//Interrupt initialisation code
	option_reg = 0xC0;


	//Delay
	//Delay: 500 ms
	delay_ms(255);
	delay_ms(245);


	//Call Component Macro
	//Call Component Macro: SPI(0)::SPI_Init
	FCD_SPI0_SPI_Init();


	//Call Macro
	//Call Macro: RTCwrite(0x8f, 0x00)
	FCM_RTCwrite(0x8f, 0x00);


	//Delay
	//Delay: 1 ms
	delay_ms(1);


	//Call Macro
	//Call Macro: RTCwrite(0x81, 0x00)
	FCM_RTCwrite(0x81, 0x00);


	//Call Macro
	//Call Macro: RTCwrite(0x80, 0x00)
	FCM_RTCwrite(0x80, 0x00);


	//Loop
	//Loop: While 1
	while( 1 )
	{
		//Call Macro
		//Call Macro: sec_val=RTCread(0x00)
		FCV_SEC_VAL = FCM_RTCread(0x00);


		//Call Macro
		//Call Macro: min_val=RTCread(0x01)
		FCV_MIN_VAL = FCM_RTCread(0x01);


		//Call Macro
		//Call Macro: hr_val=RTCread(0x02)
		FCV_HR_VAL = FCM_RTCread(0x02);


		//Call Macro
		//Call Macro: LEDtime(min_val, sec_val)
		FCM_LEDtime(FCV_MIN_VAL, FCV_SEC_VAL);


	}


	mainendloop: goto mainendloop;
}

void interrupt(void)
{
	 
}

